.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include PWDGEN.inc
   


.data
	_dbAppName 						db 		"PWDGEN",0
	_bSeedLen 						BYTE 	0
	_dbSpecChars 					db 		")!@#$%^&*(",0
	_dbAlphaChars 					db 		"abcdefghijklmnopqrstuvwxyz",0
	_dbConfigFileName 				db 		"PWDGEN.CONFIG",0
	_dbConfigFileNotFoundCaption 	db 		"Config File Not Found", 0
	_dbConfigFileNotFoundText 		db 		"The PWDGEN config file was not found. The config file, PWDGEN.CONFIG, contains the password generation algorithm with instructions for how to generate your own personal password based on a user specified seed string.", 0
	_dbSpaceString					db 		" ",0


	_dwFileDataPtr 					DWORD 	0	; Config File Data, point to the beginning of the file
	_dwFileLen						DWORD 	0 	; Config File Length, in bytes
	_dwLineDataPtr 					DWORD 	0	; Pointer to Config File Lines, pointer to an array of pointers
	_dwLineCount 					DWORD 	0 	; Config File line Count
	_lpString 						DWORD 	0	; Gereric String pointer 
	

	
.data?
	_dwSeedBufferBytePtr 			db 55 dup(?) 	; a string buffer used to store the seed that the user enters in the dialog, should never get changed except through user input
	_dwPasswordBufferBytePtr 		db 55 dup(?)	; a string buffer used to store the generated password
	_dbString1 						db 55 dup(?)	; a string buffer used to hold a character or ascii number string that will be manipulated by a character picker function, a working area
	_dbString2 						db 55 dup(?)	; a string buffer used to hold the seed temporarily an to operate on the seed with character picker functions 
	hMenu HANDLE ? 
	
	
	
.const
	IDC_GRP1 equ 1001
	IDC_EDT1 equ 1002
	IDC_EDT2 equ 1003
	IDC_BTN1 equ 1004 
	IDC_CHK1 equ 1005
	IDC_LST1 equ 1006
	IDC_CHK2 equ 1007
	
	
IDM_COPY                      equ  40006
IDM_PASTE                     equ 	40008
.code
	

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax
	
	; Check for config file PWDGEN.CONFIG, it is required 
	invoke exist,addr _dbConfigFileName
	.if eax==0
		invoke MessageBox, NULL,addr _dbConfigFileNotFoundText, addr _dbConfigFileNotFoundCaption, MB_OK
		invoke ExitProcess,0		; Exit f file is not found
	.endif
	
    invoke InitCommonControls
   
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	
	invoke ExitProcess,0

	
;########################################################################


DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	; This is the main windows message processing loop
	; Messages generated in the dialog get sent here for processing
	; Messages
	; WM_INITDIALOG
	; WM_COMMAND
	; WM_CLOSE

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		
		invoke LoadIcon,hInstance,500 ;our first Win API loading icon to our created window
	    mov hIcon,eax ;the result loaded is stored in the eax register, our first OPCODE mov puts it into the hIcon variable.
    	invoke SendMessage,hWin,WM_SETICON,NULL,hIcon ;our second WIN API sets the loaded icon to our dialog 
		;invoke SendDlgItemMessage, hWin, IDC_EDT1, EM_SETPASSWORDCHAR,  '+',  0
		invoke SendDlgItemMessage, hWin, IDC_EDT1, EM_SETLIMITTEXT , 50, 0
		invoke SendMessage, hWin, DM_SETDEFID,  IDC_BTN1,  0
		
		invoke  GetDlgItem,hWin,IDC_EDT1
		invoke  SetWindowSubclass,eax,ADDR EditBox1,0,0
		invoke  GetDlgItem,hWin,IDC_EDT2
        invoke  SetWindowSubclass,eax,ADDR EditBox2,0,0
		
		 
	.elseif eax==WM_INITMENUPOPUP
		mov eax, wParam
			
	.elseif eax==WM_COMMAND
		mov eax,wParam 
			.IF ax==IDC_CHK1
				Invoke SendDlgItemMessage, hWin, IDC_CHK1, BM_GETCHECK, 0, 0
				.if eax == BST_CHECKED
					invoke SendDlgItemMessage, hWin, IDC_EDT1, EM_SETPASSWORDCHAR,  '*',  -1
				.else
					invoke SendDlgItemMessage, hWin, IDC_EDT1, EM_SETPASSWORDCHAR,  NULL,  -1
				.endif

				; This is where I would like to modify the behavior of the Edit Controls, after the check box is cecked to turn them into password style boxes, 
				; I can't copy them, but when I remove the password char, I can copy them, I think it seems reasonable that I could alter the behavior
				invoke  GetDlgItem,hWin,IDC_EDT1
				mov hMenu, eax
				invoke GetMenu, hMenu 
				;invoke EnableMenuItem, eax, IDM_COPY, MF_ENABLED
				invoke EnableMenuItem, eax, IDM_PASTE, MF_GRAYED
				
				
				;This invalidates the dlg and cause it to redraw, without it, I can't get the edit contol to redraw after I set its password char until I click on it
				invoke InvalidateRect, hWin, NULL, FALSE	
			.ENDIF
			.IF ax==IDC_CHK2
				Invoke SendDlgItemMessage, hWin, IDC_CHK2, BM_GETCHECK, 0, 0
				.if eax == BST_CHECKED
					invoke SendDlgItemMessage, hWin, IDC_EDT2, EM_SETPASSWORDCHAR,  '*',  -1
				.else
					invoke SendDlgItemMessage, hWin, IDC_EDT2, EM_SETPASSWORDCHAR,  NULL,  -1					
				.endif
				;This invalidates the dlg and cause it to redraw, without it, I can't get the edit contol to redraw after I set its password char until I click on it
				invoke InvalidateRect, hWin, NULL, FALSE	
			.ENDIF
            .IF ax==IDC_BTN1 		;The user pressed the GO button
            	
                invoke GetDlgItemText,hWin,IDC_EDT1,ADDR _dwSeedBufferBytePtr,512
                
                invoke StrLen,addr _dwSeedBufferBytePtr
            	mov [_bSeedLen], al
 			
			
				;----------------
				
				invoke GetDlgItemText,hWin,IDC_EDT1,ADDR _dwSeedBufferBytePtr,512
				invoke SendDlgItemMessage, hWin, IDC_LST1, LB_RESETCONTENT, 0, 0	; Reset the listbox
			
			
				invoke ReadConfig			;Read the PWDGEN.CONFIG
				mov  _dwLineCount, eax		
			    mov  _dwLineDataPtr, ecx
			    mov  _dwFileDataPtr, ebx
			    mov  _dwFileLen, edx
				
			
				invoke ProcessSeed, _dwLineDataPtr, _dwLineCount, hWin
				free _dwLineDataPtr
	    		free _dwFileDataPtr	
				;---------------- 
            .ENDIF
  		
	.elseif eax==WM_CLOSE
		
		invoke EndDialog,hWin,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp
EditBox1 PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM,uIdSubClass:DWORD,dwRefData:DWORD
 LOCAL nLen:DWORD
 LOCAL hMem:DWORD
 LOCAL pMem:DWORD
 LOCAL buffer[55]:BYTE
 LOCAL buffer2[55]:BYTE
 LOCAL pSelStart:DWORD
 
 push esi		; Preserve Register
 push edi		; Preserve Register
 
 invoke FillMem, addr buffer, 	55,0H							; initialize/Re-initialize string variable with 0's
 invoke FillMem, addr buffer2, 	55,0H							; initialize/Re-initialize string variable with 0's
    .IF uMsg == WM_CONTEXTMENU 
        xor     eax,eax											; Handling this message prevents the popup created normally when the edit control is right-clicked
        ret
    .ENDIF
    .IF uMsg == WM_COPY 
   	
		invoke SendMessage, hWnd, WM_GETTEXT, 256, addr buffer	; Store Text from Edit control in buffer
		invoke SendMessage,hWnd,EM_GETSEL, addr pSelStart, 0	; Get sel start and end, start in loword ax, end in hiword
		xor ecx, ecx											; Clear ecx
		mov cx, ax												; move start sel position to ecx
		xor eax, ecx											; remove start position from eax leaving end sel position in hiword
		rol eax, 16												; rotate register so end sel position is in loword 	
		sub eax, ecx											; subtrat start sel position form end sel position to get length of selection
		invoke szMid, addr buffer, addr buffer2, ecx, eax		; extract selected text, start at ecx and get eax characters
		
		invoke StrLen,addr buffer2								; Don't really need this because eax already contains length 
		inc eax													; Increment eax to account for trailing 0 in sz string											
        mov nLen, eax											; Store length
        
        invoke OpenClipboard,0									; Open Clipboard

        invoke GlobalAlloc,GHND,nLen							; Allocate Globale Memory
        mov hMem,eax											; Store handle

        invoke GlobalLock,hMem 									; Lock memory
        mov pMem,eax											; Store pointer

        lea esi,buffer2											; Copy buffer2 to the memory allocated
        mov edi,pMem 											
        mov ecx,nLen
        rep movsb

        invoke EmptyClipboard									; Clear the clipboard

        invoke GlobalUnlock,hMem 								; Unlock the memory

        invoke SetClipboardData,CF_TEXT,hMem					; Set the Clipboard Text

        invoke CloseClipboard									; Close the Clipboard

        invoke SendMessage,hWnd,WM_DESTROY,0,0					; Destroy control instance
        xor     eax,eax											; Indicate the message was handled
        	
        pop edi													; Restore Register
        pop esi													; Restore Register
        ret

    .ENDIF
    
    invoke  DefSubclassProc,hWnd,uMsg,wParam,lParam				; Use default message handling for messages not handled by subclassing
    pop edi														; Restore Register
    pop esi           											; Restore Register
    ret

EditBox1 ENDP


EditBox2 PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM,uIdSubClass:DWORD,dwRefData:DWORD
  LOCAL nLen:DWORD
 LOCAL hMem:DWORD
 LOCAL pMem:DWORD
 LOCAL buffer[55]:BYTE
 LOCAL buffer2[55]:BYTE
 LOCAL pSelStart:DWORD
 
 push esi		; Preserve Register
 push edi		; Preserve Register
 
 invoke FillMem, addr buffer, 	55,0H							; initialize/Re-initialize string variable with 0's
 invoke FillMem, addr buffer2, 	55,0H							; initialize/Re-initialize string variable with 0's
    .IF uMsg == WM_CONTEXTMENU 
        xor     eax,eax											; Handling this message prevents the popup created normally when the edit control is right-clicked
        ret
    .ENDIF
    .IF uMsg == WM_COPY 
   	
		invoke SendMessage, hWnd, WM_GETTEXT, 256, addr buffer	; Store Text from Edit control in buffer
		invoke SendMessage,hWnd,EM_GETSEL, addr pSelStart, 0	; Get sel start and end, start in loword ax, end in hiword
		xor ecx, ecx											; Clear ecx
		mov cx, ax												; move start sel position to ecx
		xor eax, ecx											; remove start position from eax leaving end sel position in hiword
		rol eax, 16												; rotate register so end sel position is in loword 	
		sub eax, ecx											; subtrat start sel position form end sel position to get length of selection
		invoke szMid, addr buffer, addr buffer2, ecx, eax		; extract selected text, start at ecx and get eax characters
		
		invoke StrLen,addr buffer2								; Don't really need this because eax already contains length 
		inc eax													; Increment eax to account for trailing 0 in sz string											
        mov nLen, eax											; Store length
        
        invoke OpenClipboard,0									; Open Clipboard

        invoke GlobalAlloc,GHND,nLen							; Allocate Globale Memory
        mov hMem,eax											; Store handle

        invoke GlobalLock,hMem 									; Lock memory
        mov pMem,eax											; Store pointer

        lea esi,buffer2											; Copy buffer2 to the memory allocated
        mov edi,pMem 											
        mov ecx,nLen
        rep movsb

        invoke EmptyClipboard									; Clear the clipboard

        invoke GlobalUnlock,hMem 								; Unlock the memory

        invoke SetClipboardData,CF_TEXT,hMem					; Set the Clipboard Text

        invoke CloseClipboard									; Close the Clipboard

        invoke SendMessage,hWnd,WM_DESTROY,0,0					; Destroy control instance
        xor     eax,eax											; Indicate the message was handled
        	
        pop edi													; Restore Register
        pop esi													; Restore Register
        ret

    .ENDIF
    
    invoke  DefSubclassProc,hWnd,uMsg,wParam,lParam				; Use default message handling for messages not handled by subclassing
    pop edi														; Restore Register
    pop esi           											; Restore Register
    ret

EditBox2 ENDP
FillMem proc lpMem:DWORD, count:DWORD, fill:BYTE
    ;    invoke memory_clear, addr _dwString1, LENGTHOF _dwString1,"x"
    ;    invoke memory_clear, addr _dwString1, LENGTHOF _dwString1,0H
    push edi

    mov edi, lpMem              ; Pointer to memory
    xor edx, edx                ; prevent stall on WORD write
    mov dl, fill                ; Value to initialize memory with
    mov dh, fill

    mov ecx, count              ; number of bytes to write
    push ecx

    mov WORD PTR count[0], dx   ; reuse "count" variable
    mov WORD PTR count[2], dx

    mov eax, count
    shr ecx,2                   ; numbers of dwords to write
    rep stosd

    pop ecx
    and ecx,3                   ; number of remaining bytes to write

    xor eax, eax                ; prevent stall on following BYTE write
    mov al, fill
    rep stosb

    pop edi

    ret

FillMem endp

ProcessSeed proc  dwLineDataPtr:DWORD,dwLineCount:DWORD, hWin:HWND
	; This procedure processes the seed entered by the user
	; dwLineDataPtr - a Pointer to an array of pointers that point to the individual lines from the config file
	; dwLineCount 	- a value indicating how many lines are in the config file
	; hWin			- a handle to the dialog window  
	
	LOCAL dwCharPickerFuncPtr	:DWORD		; Pointer to an array of pointers, used to tokenize the individual config file lines into character picker function tokens 
	LOCAL dwCharPickerFuncCount :DWORD		; Value indicating how many character picker function token are in a specific line from the config fle
	LOCAL dwSeedLength 			:DWORD		; Value indicating the length in characters of the seed provided by the user
	
	
	xor ebx, ebx							; Zero out ebx, used as a counter to control the outter loop below which processes the config file lines from top to bottom
	.while ebx < dwLineCount				; Process the config file lines until they have all been processed
		mov esi, dwLineDataPtr				; Use esi to dereference the line pointer array
		
		invoke SendDlgItemMessage, hWin, IDC_LST1, LB_ADDSTRING, 0, [esi + [ 4 * ebx]]	; Add each Character Picker algorithm Line to the listbox for the user to see

		; Sometimes the character picker algorithm refers to a single character in the seed, 
		; This happens when the algorithm contains a $SEED token followed by an open paren, i.e. $SEED(2), refering to the second character of the seed
		; Isolate seed character into _dwString1
		invoke IsSeedIndexFunction, [esi + [ 4 * ebx]]	; return character indicated by seed index in al
		
		.if eax > 0										; if eax > 0 then the algorithm does refer to a single character
			lea ecx, _dbString1							; create pointer to _dbString1
			mov byte ptr [ecx], al 		 				; Put the seed character in _dbString1
		.endif
			
		; Sometimes the character picker algorithm refers to the entire seed string,
		; This happens when the algorithm contains a $SEED token with no open paren directly afterwards, i.e. Length($SEED)
		; Copy the seed into _dbString2 which may be used later by some of the character picker algorithm functions 
		invoke FillMem, addr _dbString2, 55,0H	; initialize/Re-initialize string variable with 0's
		cld
		lea esi, _dwSeedBufferBytePtr
		lea edi, _dbString2
		mov _lpString, esi					; create pointer to _dbString1
		mov dwSeedLength,  len(_lpString)	; save seed length in dwSeedLength
		mov ecx, dwSeedLength				; use it to get length
		rep movsb
			
		; tokenize line data to create array of Character Picker Function pointers
		mov esi, dwLineDataPtr									; Store pointer to line array in esi
																; Use ebx and esi to dereference the lines 
																; Pass a pointer to the desired line into the TokenizeCharacterFunction	to create an array of pointers to the functions in the line 
		mov dwCharPickerFuncCount, rv(TokenizeCharacterFunction,[esi + [ 4 * ebx]], ADDR dwCharPickerFuncPtr)  ; Store the token count in dwCharPickerFuncCount
		mov esi, dwCharPickerFuncPtr							; Now use edi and esi to dereference into the Character Picker Functions
		xor edi, edi											; Zero out edi
		mov edi, dwCharPickerFuncCount
			; The inner loop seeks to process each character picker algorithm function
			; The result of each function shoul dbe stored as a zero terminated string in _dbString1
			; Some functions will use the value found in the _dbString1, process it according to the function indicated and then store the processed character back into _sbString1 
			; (ToUpper, ToLower, ShiftRight) <--Generally reference a character
			; Some functions will start with _dbSeed2 and store the result into _dbSeed1
			; (Last, Length, Modulus, SpecialCharacter, AlphaPointer)	<--Generally reference a numeric value
			;  
			.while edi > 0										; Loop backwards through the Character Picker Function Tokens, i.e. process from the inside out
				push edi										; For debug, see the character picker function count
				push [esi + 4 * edi - 4]						; For debug, see the character picker function
				pop edi											; Cleanup stack
				pop edi											; Cleanup stack
				
				switch$ [esi + 4 * edi - 4]						; Inspect the Character Picker Function Token and execute indicated function
					case$ "TOUPPER"								; Upper case the indicated character
						lea eax, _dbString1						; Create a pointer to _dbString1
						mov _lpString, eax						
					   	mov _lpString, ucase$(_lpString)		; Upper case _dbString1	
					   		
					case$ "TOLOWER"								; Lower case the indicated character
						lea eax, _dbString1						; create a pointer to _dbString1
						mov _lpString, eax						
					   	mov _lpString, lcase$(_lpString)		; Lower case _dbString1
					   		
					case$ "SHIFTRIGHT"							; Shift the indicated character right alphabetically
						lea eax, _dbString1						; Create a pointer to _dbString1
						mov _lpString, eax						
						mov ecx, [esi + 4 * edi]				; Get the ShiftRight count from the next pointer, remember, we're going in reverse order
			            invoke atol, ecx						; Convert the ascii to a number value and put in al
			           	mov ecx, _lpString
			           	xor edx, edx
			           	mov dl, byte ptr [ecx]					; Move the first character of _dbString1 to dl
		            	invoke ShiftRight, dl, al				; Shift the character right along the alphabet for the indicated number of places, put shifted character in ah
		            	mov ecx, _lpString
		            	mov byte ptr [ecx], ah					; The shifted character is in ah, move it to _dbStrng1
		            	
					case$ "LAST"								; Get the last character in the seed
						lea eax, _dbString2						; Create a pointer to _dbString2
						mov _lpString, eax						
					   	mov _lpString, right$(_lpString,1)		; Overwrite _dbString2 with the right most character of _dbString2
					   	lea eax, _dbString2						; Create a pointer to _dbString2
					   	mov al, byte ptr [eax]
					   	lea ecx, _dbString1						; Create a pointer to _dbString1
					   	mov byte ptr [ecx], al					; Move the character into _dbString1 

					case$ "LENGTH"								; Get the length of the seed, 
																; We don't need to look at _dbString2 in this case 
																; Because we already know the length of it is stored in dwSeedLength							
						lea ecx, _dbString1						; Create a pointer to _dbString1
              			mov _lpString, ecx
						invoke ltoa, dwSeedLength, _lpString	; Convert the length to a string and store it in _dbSting1
						
					case$ "MODULUS"								; Modulus operations always use the seed length as the dividend 
						mov ecx, [esi + 4 * edi]				; Grab the modulus divisor, it is referenced by a separate character picker function pointer
						invoke atol, ecx						; Convert the string representation of the divisor to a numeric value, i.e. "11" becomes 11
						mov ecx, dwSeedLength					; Store the seed length in ecx
              			invoke GetMod, cl, al					; Call GetMod, remainder is returned in ah
              			add ah, 30h								; Add 30H to convert the number in ah to ascii
              			lea ecx, _dbString1						; Create a pointer to _dbString1
              			mov _lpString, ecx
              			mov byte ptr [ecx], ah					; Store the remainder, modulus, into _dbString1

              		case$ "SPECCHARPOINTER"						; Use _dbString1 as a pointer to a character in the Special Character list, This funcion assumes that _dbString1 contains a string representation
              													; Of a number to use as a pointer, the pointer should be a Zero based index into the Special Character List 
						xor eax, eax
              			lea ecx, _dbString1						; Create a pointer to _dbString1
              			invoke atol, ecx						; Convert the string into a number
              			invoke SpecCharPointer, eax				; Pass the converted index number to SpecCharPointer, return the special character in al
		              	lea ecx, _dbString1						; Create a pointer to _dbString1
              			mov _lpString, ecx
		              	mov byte ptr [ecx], al					; Move the special character to _dbString1
		              	
		            case$ "ALPHAPOINTER"						; Use _dbString1 as a pointer to a character in the alphabet, This funcion assumes that _dbString1 contains a string representation
              													; Of a number to use as a pointer, the pointer should be a One based index into the alphabet, it can be greater than 26 because it wraps around
		            	xor eax, eax
		            	lea ecx, _dbString1						; Create a pointer to _dbString1
		            	invoke atol, ecx						; Convert the string into a number
	            		invoke AlphaPointer, eax				; Pass the converted index number to AlphaPointer, return the character in al
						lea ecx, _dbString1						; Create a pointer to _dbString1
              			mov _lpString, ecx					
		              	mov byte ptr [ecx], al					; Move the character to _dbString1

			     	else$										; A catch all for unrecognized tokens, it is expected that some of the tokens will not be recognized
			     		nop										; The character picker function tokens that are recognized are listed in the case$ statements above
																; The line tokenizer uses an open paren "(" to break up the line, as a result, soe weird stuff sometimes is treated like a complete token
																; If it does not match a known token, it is ignored here
				endsw$
				sub edi,1										; Decrement the inner loop counter
			.endw												; End of inner character picker function loop

		; At this point we have completed applying all of the character picker functions of one of the algorithm lines
		; The final result is stored in the _dbString1 as a single character
		; It needs to be moved into the appropriate spot of the password buffer
		xor eax, eax											; Zero eax
		lea edx, _dbString1										; Create a pointer to _dbString1 
		mov al, byte ptr [edx]									; Move the character to al
		lea ecx, [_dwPasswordBufferBytePtr+ebx]				; Create a pointer to the correct location in the password buffer using ebx to help index it
		mov byte ptr [ecx], al									; Move the character into th epassword buffer
		add ebx, 1												; Increment ebx to go to next line
    .endw
    
    mov ecx, offset _dwPasswordBufferBytePtr					; Re-establish ecx as the base pointer for the password buffer because ecx was used above
    invoke SendDlgItemMessage, hWin, IDC_EDT2, WM_SETTEXT, 0, addr _dwPasswordBufferBytePtr
    
    
	ret

ProcessSeed endp	

AlphaPointer proc dwIndex:DWORD
	
	; AlphaPointer accepts a one based index value which is used to reference a character in the alphabet
	; The function handles index values greater than 26 by rotating back to 1, i.e 27 = "a"
	; --------
	; On ENTRY
	; --------
	; dwIndex contains a value indicating the character in the alphabet desired
	; -------
	; On EXIT
	; -------
	; al contains the lower case character specified
	
	; preserve registers
	
	push ebx
	push ecx
	
	mov ebx, dwIndex
	.while ebx > 26
		sub ebx, 26
	.endw

	lea ecx, _dbAlphaChars
	xor eax, eax
	mov al, byte ptr [ecx + ebx - 1]
	
	pop ecx
	pop ebx

	ret

AlphaPointer endp
SpecCharPointer proc dwIndex:DWORD
	; SpecCharPointer accepts a zero based index value which is used to reference a character in the special character list
	; Index values greater than the number of special characters in the list are handled by rotating back to 0
	; --------
	; On ENTRY
	; --------
	; dwIndex contains a value indicating the character in the special character list desired
	; -------
	; On EXIT
	; -------
	; al contains the special character list specified
	
	; preserve registers
	
	push ebx
	push ecx
	
	mov ebx, dwIndex
	.while ebx > 9
		sub ebx, 9
	.endw

	lea ecx, _dbSpecChars
	xor eax, eax
	mov al, byte ptr [ecx + ebx]
	
	pop ecx
	pop ebx

	ret

	
	ret

SpecCharPointer endp
IsSeedIndexFunction proc dwAlgoLinePtr:DWORD
	; Parse the Algorithm component to determine if it is referencing a single index of the seed
	; If a single  index of the seed is referenced, return the seed character in ah
	; otherwise return 0 in eax
	; return -1 in eax if the Algorithm component cannot be properly parsed
	
	; On ENTRY
	; --------
	; dwAlgoLinePtr contains a pointer the the Algorithm Line to be used
	; dwSeedPtr contains a pointer to the actual seed
	; -------
	; On EXIT
	; -------
	; al contains the character specified byt the seed index
	; or eax will be zero indicating the Algoritm does not reference an individual character
	; or eax will be -1, FFFFFFFF, indicating the Algorithm Line couldnot be processed because the string, "$SEED" coul dnot be found
	
	; Setup some local variables
	LOCAL dwSeedStrPtr 		:DWORD		; This pointer will be set to an offset in dwAlgoLinePtr to indicate the start position of the string "$SEED"
	LOCAL dwSeedStartPos 	:DWORD 		; This value will be set to the actual index value within dwAlgoLinePtr indicating the start position index of the string, "$SEED"
	LOCAL dwOpenParenPtr 	:DWORD		; This pointer gets set to a pointer to a zero terminated string containing a single open paren "("
	LOCAL dwOpenParenPos 	:DWORD		; This value will be set to the actual index value within dwAlgoLinePtr indicating the start position index of the string, "("
	LOCAL dwCloseParenPtr 	:DWORD		; This pointer gets set to a pointer to a zero terminated string containing a single open paren ")"
	LOCAL dwCloseParenPos 	:DWORD		; This value will be set to the actual index value within dwAlgoLinePtr indicating the start position index of the string, ")"
										; (dwCloseParenPos - dwOpenParenPos - 1) will indicate the length of the text contained within the open and close paren, i.e. $SEED(4), the length is 1 
	LOCAL dwIndexBufferPtr 	:DWORD		; This buffer is used to contain the result of the szMid instruction, its the ascii representation of the numeric index specified 
	mov edx, dwAlgoLinePtr
	push ecx
	push ebx
	
	
	; Initialize the local string vars so they can be used in the sz string functions
	sas  dwSeedStrPtr, "$SEED"
	sas  dwOpenParenPtr, "("
	sas  dwCloseParenPtr, ")"
	sas  dwIndexBufferPtr, 0
	
	mov eax, dwIndexBufferPtr
	
	; find the start position of the string "$SEED" in the algorithm
	
	invoke InString, 1, dwAlgoLinePtr, dwSeedStrPtr
	
	; if it does not exist, jump to exit with -1
	cmp eax, 0
	je ErrorParsingForSeedToken
	
	; find the start position of the string "(" in the algorithm
	invoke InString, eax, dwAlgoLinePtr, dwOpenParenPtr
	cmp eax, 0
	je NoIndexSpecified
	mov dwOpenParenPos, eax

	; find the start position of the string ")" in the algorithm	
	invoke InString, eax, dwAlgoLinePtr, dwCloseParenPtr
	mov dwCloseParenPos, eax
	
	
	; convert eax to a value indicating the number of bytes to read from the algorithm to extract the index
	sub eax, dwOpenParenPos ;Subtract StartPos of "(" from Start Pos of ")" to get number of bytes to read in szMid operation
	sub eax, 1 				;get rid of the ")"
	
	; retrieve the text contained within the open and close parens immediately following $SEED in the algorithm and plaze at addr _dbIndexBuffer
	invoke szMid, dwAlgoLinePtr, dwIndexBufferPtr, dwOpenParenPos, eax
	
	; convert the ascii text pulled from the algorithm to a 32-bit signed integer
	invoke atol, dwIndexBufferPtr		;eax now contains the 1 based value of the index
	
	mov ecx, eax							;store the index in ecx temporarily to be used in calculating the position of the indicated character within the actual seed string
	mov ebx, offset _dwSeedBufferBytePtr 	;ebx points to the first character
    xor eax, eax
    mov al, byte ptr [ebx+ecx-1] 			;move the specified character to ah
	
	jmp Return
	NoIndexSpecified:
	xor eax, eax
	jmp Return
	ErrorParsingForSeedToken:
	mov eax, -1;
	jmp Return
	Return:
	pop ebx
	pop ecx
	ret

IsSeedIndexFunction endp
ReadConfig proc 
	

	; ReadConfig will read the config file to obtain the _dwPasswordBufferBytePtr algorithm
	; -------
	; On EXIT
	; -------
	; 1. EAX will contain the number of lines in the file
	; 2. ECX will contain a pointer to an array of pointers to the lines of the file	
	; 3. EBX will contain a pointer to the beginning of the config file in memory
	; 4. EDX will contain the number of bytes contained in the file
	

	LOCAL dwFileDataPtr 	:DWORD ;Starting location of File Data
	LOCAL dwFileLen			:DWORD ;Byte Count from File
	LOCAL dwLineDataPtr		:DWORD ;Pointer to the array of line addresses
	LOCAL dwLineCount		:DWORD ;Count of the lines in the file
	
    mov dwFileDataPtr, InputFile("PWDGEN.CONFIG") 		; POST EAX contain start of Data, ECX contains legth of data, Moves EAX to dwFileDataPtr
    mov dwFileLen, ecx									; store file length in dwFileLen

	
	mov dwFileDataPtr, remove$(dwFileDataPtr, chr$(32))							; Remove space from config file
	
							
	mov eax, ucase$(dwFileDataPtr)		; Upper case _dbString1	
					   		
    mov dwLineCount, rv(TokenizeConfigFile,dwFileDataPtr,ADDR dwLineDataPtr) 	; <<<< NOTE the ADDR of hArr
 
    
    
    mov eax, dwLineCount	;Return the line count in eax
    mov ecx, dwLineDataPtr	;Return the line pointer in ecx
    mov ebx, dwFileDataPtr 	;Return the file memory pointer in ebx, don't really need this because we could get it from the first line pointer
    mov edx, dwFileLen		;Return the file length in edx
    
    ;Somewhere down the road, when the data is not needed anymore, we need to call the free macro or GlobalFree() on this memory
    ;free dwFileDataPtr
    ;free dwLineDataPtr

	ret

ReadConfig endp	

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
TokenizeConfigFile proc ptxt:DWORD,hArr:DWORD


  ; --------
  ; On ENTRY
  ; --------
  ; ptxt is the address of the text to tokenize.
  ; hArr is the address of a variable to receive the pointer array address

  ; -------
  ; On EXIT
  ; -------
  ; 1. pointer array has the address of each line
  ; 2. the return value in EAX is the line count

  ; -------------------------------
  ; When data is no longer required
  ; -------------------------------
  ; The passed variable "hArr" must be freed with GlobalFree()
  ; or the macro "free"

    mov ecx, [esp+4]            ; ptxt
    xor edx, edx
    sub ecx, 1

  ; --------------------------
  ; count the carriage returns
  ; --------------------------
  lp1:
    add ecx, 1
    movzx eax, BYTE PTR [ecx]
    test eax, eax
    jz lout
    cmp eax, 13
    jne lp1
    add edx, 1
    jmp lp1

  ; -----------------------------------
  ; set buffer size and allocate memory
  ; -----------------------------------
  lout:
    add edx, 1
    push edx                    ; preserve count on stack
    lea edx, [edx*4]            ; mul edx * 4
    add edx, 64
    mov edx, alloc(edx)         ; allocate the pointer array memory
    mov eax, [esp+8][4]         ; hArr - write the passed handle address to EAX
    mov [eax], edx              ; write the allocated memory handle to it
    mov ecx, [esp+4][4]         ; ptxt - text address in ECX
    mov [edx], ecx              ; 1st line address in 1st DWORD in EDX
    add edx, 4
    sub ecx, 1

  mainloop:
    add ecx, 1
  backin:
    movzx eax, BYTE PTR [ecx]   ; test each byte
    test eax, eax               ; exit on zero
    jz lpout
    cmp eax, 13                 ; test for CR
    jne mainloop                ; loop back if not

    mov BYTE PTR [ecx], 0       ; overwrite 13 with 0
    add ecx, 2                  ; set next line start
    mov [edx], ecx              ; store it in the pointer array
    add edx, 4
    jmp backin
   
  lpout:
    pop eax                     ; restore count into EAX as return value

    ret 8						;discards parameters from the stack because of the 8

TokenizeConfigFile endp
TokenizeCharacterFunction proc ptxt:DWORD, hArr:DWORD
	
  ; --------
  ; On ENTRY
  ; --------
  ; ptxt is the address of the text to tokenize.
  ; hArr is the address of a variable to receive the pointer array address

  ; -------
  ; On EXIT
  ; -------
  ; 1. pointer array has the address of each line
  ; 2. the return value in EAX is the line count

  ; -------------------------------
  ; When data is no longer required
  ; -------------------------------
  ; The passed variable "hArr" must be freed with GlobalFree()
  ; or the macro "free"

    mov ecx, [esp+4]            ; ptxt
    xor edx, edx
    sub ecx, 1

  ; --------------------------
  ; count the carriage returns
  ; --------------------------
  lp1:
    add ecx, 1
    movzx eax, BYTE PTR [ecx]
    test eax, eax
    jz lout
    
    cmp eax, 28H
    je found
    cmp eax, 2CH
    jne lp1
    
    found:
    add edx, 1
    jmp lp1

  ; -----------------------------------
  ; set buffer size and allocate memory
  ; -----------------------------------
  lout:
    add edx, 1
    push edx                    ; preserve count on stack
    lea edx, [edx*4]            ; mul edx * 4
    add edx, 64
    mov edx, alloc(edx)         ; allocate the pointer array memory
    mov eax, [esp+8][4]         ; hArr - write the passed handle address to EAX
    mov [eax], edx              ; write the allocated memory handle to it
    mov ecx, [esp+4][4]         ; ptxt - text address in ECX
    mov [edx], ecx              ; 1st line address in 1st DWORD in EDX
    add edx, 4
    sub ecx, 1

  mainloop:
    add ecx, 1
  backin:
    movzx eax, BYTE PTR [ecx]   ; test each byte
    test eax, eax               ; exit on zero
    jz lpout
    cmp eax, 28H                 ; test for (
    je found2
    cmp eax, 2CH
	jne mainloop
	
	
	found2:	
    mov BYTE PTR [ecx], 0       ; overwrite 13 with 0
    ;add ecx, 2                  ; set next line start
    add ecx, 1                  ; set next line start
    mov [edx], ecx              ; store it in the pointer array
    add edx, 4
    jmp backin
   
  lpout:
    pop eax                     ; restore count into EAX as return value

    ret 8						;discards parameters from the stack because of the 8

TokenizeCharacterFunction endp
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

GetMod proc dvdnd:BYTE, dvsr:BYTE
	; The GetMod function conducts a div operation and returns the modulus or remainder of the div operation in ah
	; --------
	; On ENTRY
	; --------
	; dvdnd contains the dividend to use in the modulus operation
	; dvsr contains the divisor to use in the modulus operation
	; -------
	; On EXIT
	; -------
	; al contains quotient result of div operation
	; ah contains the remainder or modulus
	
			push ebx		; preserve ebx	
	        xor eax, eax
	        xor ebx,ebx
	        mov al, dvdnd
	        mov bl, dvsr
            div bl
    		pop ebx			; restore ebx
            
	ret

GetMod endp
IsEven proc dvdnd:BYTE
	; The IsEven function returns a value indicating if the specified number is even
	; --------
	; On ENTRY
	; --------
	; dvdnd contains the number to evaluate 
	; -------
	; On EXIT
	; -------
	; ah contains 1 if the dvdnd is even, 0 if it is odd
	        xor eax, eax
	        xor ebx,ebx
	        mov al, dvdnd
	        mov bl, 2
            div bl
			;Remainder is in ah
			cmp ah, 0
			je evennum
			mov ah, 0
			jmp LeaveIsEven
			evennum:	
			mov ah,1	;Number is even so return true
			LeaveIsEven:
	ret

IsEven endp

ShiftRight proc char:BYTE, rtcnt:BYTE
	; The ShiftRight shifts the specified letter to the right alphabetically 
	; the specified number of places and returns the result. The function maintains
	; the case of the specified charatcer. Shifting to the right past the letter z/Z 
	; wraps around to a/A. 
	; --------
	; On ENTRY
	; --------
	; char contains the letter to shift
	; rtcnt contains the number of spaces to the right to shift 
	; -------
	; On EXIT
	; -------
	; ah contains the result of the ShiftRight operation	
	
		mov ah, char
		cmp ah, 41h
		jl finished
		cmp ah, 5Ah
		jg checklower
		;At this point, ah contains a value from 41h to 5Ah
		;It is a capital character and needs to be shifted rtcnt characters to the right
		add ah, rtcnt
		cmp ah, 5Ah
		jle finished
		sub ah, 1Ah
		jmp finished
	checklower:
		cmp ah, 61h
		jl finished
		cmp ah, 7Ah
		jg finished
		;must be a lower case char
		add ah, rtcnt
		.if ah> 7Ah
			sub ah, 1Ah
		.endif
		finished:
		
		ret
		
	ShiftRight endp
end start

